package tr.com.bilyazilim.kosgeb.manager;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.Date;

import javax.ejb.Remove;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.AutoCreate;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.richfaces.event.UploadEvent;
import org.richfaces.model.UploadItem;

import tr.com.bilyazilim.kosgeb.util.File;
import tr.com.bilyazilim.kosgeb.util.FileWrapper;


@AutoCreate
@Name("fileUploadManager")
@Scope(ScopeType.CONVERSATION)
public class FileUploadManagerBean implements FileUploadManager, Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -92119979372586321L;

//	@In(scope=ScopeType.PAGE)
	private FileWrapper fileWrapper = new FileWrapper();

	private int uploadsAvailable = 5;

    private boolean autoUpload = true;

    private boolean useFlash = false;

    private Date timeStamp= new Date();
    
    public void paint(OutputStream stream, Object object) throws IOException {
    	stream.write((byte [])(fileWrapper.getFileList().get((Integer) object)).getData());
    	//stream.write(((FileWrapper)Contexts.getConversationContext().get("fileWrapper")).getFileList().get((Integer)object).getData());
    }


    public void listener(UploadEvent event) throws Exception{
        UploadItem item = event.getUploadItem();
        File file = new File();
        BufferedInputStream bis = new BufferedInputStream(new FileInputStream(item.getFile()));
        file.setLength(item.getFileSize());
        file.setName(item.getFileName());
        byte [] b = new byte[(int)item.getFile().length()];
        bis.read(b);
        file.setData(b);
        fileWrapper.getFileList().add(file);
        //((FileWrapper)Contexts.getConversationContext().get("fileWrapper")).getFileList().add(file);
        uploadsAvailable--;
    }

    public int getSize() {
//        if (	fileWrapper.getFileList().size()>0
//        		//((FileWrapper)Contexts.getConversationContext().get("fileWrapper")).getFileList().size()>0
//        		){
//            return fileWrapper.getFileList().size(); 
//            //((FileWrapper)Contexts.getConversationContext().get("fileWrapper")).getFileList().size();
//        }else
//        {
//            return 0;
//        }

        if (	fileWrapper!=null && fileWrapper.getFileList()!=null && fileWrapper.getFileList().size()>0
        		//((FileWrapper)Contexts.getConversationContext().get("fileWrapper")).getFileList().size()>0
        		){
            return fileWrapper.getFileList().size(); 
            //((FileWrapper)Contexts.getConversationContext().get("fileWrapper")).getFileList().size();
        }else
        {
            return 0;
        }
}

    public void clear() {
    	this.fileWrapper.getFileList().clear();
    }
	public void setUploadsAvailable(int uploadsAvailable) {
		this.uploadsAvailable = uploadsAvailable;
	}

	public int getUploadsAvailable() {
		return uploadsAvailable;
	}

	public void setAutoUpload(boolean autoUpload) {
		this.autoUpload = autoUpload;
	}

	public boolean isAutoUpload() {
		return autoUpload;
	}

	public void setUseFlash(boolean useFlash) {
		this.useFlash = useFlash;
	}

	public boolean isUseFlash() {
		return useFlash;
	}

	public void setTimeStamp(Date timestamp) {
		this.timeStamp = timestamp;
	}


	public Date getTimeStamp() {
		return timeStamp;
	}

	public FileWrapper getFileWrapper() {
		return fileWrapper;
	}


	public void setFileWrapper(FileWrapper fileWrapper) {
		this.fileWrapper = fileWrapper;
	}

	@Remove @Destroy
	public void destroy(){
		
	}


}
